## ros-rolling-bosch-locator-bridge 2.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(bosch_locator_bridge)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
# uncomment the following section in order to fill in
# further dependencies manually.
# find_package(<dependency> REQUIRED)

find_package(geometry_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(pcl_conversions REQUIRED)
find_package(rclcpp REQUIRED)
find_package(std_srvs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)

find_package(rosidl_default_generators REQUIRED)

find_package(Poco REQUIRED COMPONENTS Foundation Net JSON)

set(msg_files
    "msg/ClientControlMode.msg"
    "msg/ClientGlobalAlignLandmarkObservationNotice.msg"
    "msg/ClientGlobalAlignLandmarkVisualizationInformation.msg"
    "msg/ClientGlobalAlignVisualization.msg"
    "msg/ClientLocalizationPose.msg"
    "msg/ClientLocalizationVisualization.msg"
    "msg/ClientMapVisualization.msg"
    "msg/ClientRecordingVisualization.msg"
)

set(srv_files
    "srv/ClientConfigGetEntry.srv"
    "srv/ClientMapList.srv"
    "srv/ClientMapSend.srv"
    "srv/ClientMapSet.srv"
    "srv/ClientMapStart.srv"
    "srv/StartRecording.srv"
    "srv/ServerMapGetImageWithResolution.srv"
    "srv/ServerMapList.srv"
)

rosidl_generate_interfaces(${PROJECT_NAME}
  ${msg_files}
  ${srv_files}
  DEPENDENCIES builtin_interfaces geometry_msgs nav_msgs std_srvs
)

ament_export_dependencies(rosidl_default_runtime)

find_package(Boost REQUIRED COMPONENTS system)
find_package(PCL REQUIRED)
include_directories(${PCL_INCLUDE_DIRS})

add_executable(${PROJECT_NAME}_node
  src/main.cpp
  src/locator_bridge_node.cpp
  src/sending_interface.cpp
  src/receiving_interface.cpp
  src/rosmsgs_datagram_converter.cpp
  src/locator_rpc_interface.cpp)
set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")
target_include_directories(${PROJECT_NAME}_node PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/${PROJECT_NAME}>
  $<INSTALL_INTERFACE:include/${PROJECT_NAME}>)
target_link_libraries(${PROJECT_NAME}_node  ${Boost_LIBRARIES})
ament_target_dependencies(${PROJECT_NAME}_node
  rclcpp
  geometry_msgs
  nav_msgs
  std_srvs
  tf2_geometry_msgs
  tf2_ros
  pcl_conversions
  Poco
)

if("$ENV{ROS_DISTRO}" STREQUAL "galactic")
  add_compile_definitions(ROS_GALACTIC)
  rosidl_target_interfaces(${PROJECT_NAME}_node ${PROJECT_NAME} "rosidl_typesupport_cpp")
else()
  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(${PROJECT_NAME}_node "${cpp_typesupport_target}")
endif()

add_executable(${PROJECT_NAME}_server_node
  src/rosmsgs_datagram_converter.cpp
  src/locator_rpc_interface.cpp
  src/server/server_bridge_node.cpp
  src/server/server_main.cpp)
set_target_properties(${PROJECT_NAME}_server_node PROPERTIES OUTPUT_NAME server_node PREFIX "")
target_include_directories(${PROJECT_NAME}_server_node PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/${PROJECT_NAME}>
  $<INSTALL_INTERFACE:include/${PROJECT_NAME}>)
target_link_libraries(${PROJECT_NAME}_server_node  ${Boost_LIBRARIES})
ament_target_dependencies(${PROJECT_NAME}_server_node
  rclcpp
  std_srvs
  Poco
)

if("$ENV{ROS_DISTRO}" STREQUAL "galactic")
  add_compile_definitions(ROS_GALACTIC)
  rosidl_target_interfaces(${PROJECT_NAME}_server_node ${PROJECT_NAME} "rosidl_typesupport_cpp")
else()
  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(${PROJECT_NAME}_server_node "${cpp_typesupport_target}")
endif()

install(TARGETS ${PROJECT_NAME}_node ${PROJECT_NAME}_server_node
  EXPORT export_${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME})

install(DIRECTORY config launch
  DESTINATION share/${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # the following line skips the linter which checks for copyrights
  # uncomment the line when a copyright and license is not present in all source files
  set(ament_cmake_copyright_FOUND TRUE)
  # the following line skips cpplint (only works in a git repo)
  # uncomment the line when this package is not in a git repo
  #set(ament_cmake_cpplint_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-rolling-bosch-locator-bridge (2.1.4-1focal) focal; urgency=high

  * handle NaNs in range values
  * add service for getting config entries
  * add server interface
  * Contributors: Stefan Laible, robertwil

 -- Stefan Laible <stefan.laible@de.bosch.com>  Sun, 23 Jan 2022 23:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.3-1focal) focal; urgency=high

  * update to ROKIT Locator version 1.3
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 01 Sep 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.2-1focal) focal; urgency=high

  * guarantee that duration_rotate is greater zero
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 21 Jul 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.1-1focal) focal; urgency=high

  * add tf2_geometry_msgs dependency
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Tue, 18 May 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.0-1focal) focal; urgency=high

  * initial version
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Sun, 16 May 2021 22:00:00 -0000

=== debian/control ===
Source: ros-rolling-bosch-locator-bridge
Section: misc
Priority: optional
Maintainer: Stefan Laible <stefan.laible@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), libpoco-dev, ros-rolling-ament-cmake, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-geometry-msgs, ros-rolling-launch-xml, ros-rolling-nav-msgs, ros-rolling-pcl-conversions, ros-rolling-rclcpp, ros-rolling-rosidl-default-generators, ros-rolling-std-srvs, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-bosch-locator-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpoco-dev, ros-rolling-geometry-msgs, ros-rolling-launch-xml, ros-rolling-nav-msgs, ros-rolling-pcl-conversions, ros-rolling-rclcpp, ros-rolling-rosidl-default-runtime, ros-rolling-std-srvs, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace
Description: ROS interface to Rexroth ROKIT Locator

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-bosch-locator-bridge//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-bosch-locator-bridge 2.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
 find_package(nav_msgs REQUIRED)
 find_package(pcl_conversions REQUIRED)
 find_package(rclcpp REQUIRED)
+find_package(sensor_msgs REQUIRED)
 find_package(std_srvs REQUIRED)
 find_package(tf2_geometry_msgs REQUIRED)
 find_package(tf2_ros REQUIRED)
@@ -65,7 +66,7 @@
 
 find_package(Boost REQUIRED COMPONENTS system)
 find_package(PCL REQUIRED)
-include_directories(${PCL_INCLUDE_DIRS})
+include_directories(SYSTEM ${PCL_INCLUDE_DIRS})
 
 add_executable(${PROJECT_NAME}_node
   src/main.cpp
@@ -83,6 +84,7 @@
   rclcpp
   geometry_msgs
   nav_msgs
+  sensor_msgs
   std_srvs
   tf2_geometry_msgs
   tf2_ros
@@ -99,7 +101,6 @@
 endif()
 
 add_executable(${PROJECT_NAME}_server_node
-  src/rosmsgs_datagram_converter.cpp
   src/locator_rpc_interface.cpp
   src/server/server_bridge_node.cpp
   src/server/server_main.cpp)

=== debian/changelog ===
ros-rolling-bosch-locator-bridge (2.1.9-2jammy) jammy; urgency=high

  * Try to stop everything before setting config list (#35 <https://github.com/boschglobal/locator_ros_bridge/issues/35>)
  * Add errorFlags and infoFlags fields to ClientLocalizationPose (#33 <https://github.com/boschglobal/locator_ros_bridge/issues/33>)
  * Update to ROKIT Locator version 1.6
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 22 Mar 2023 23:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.8-2jammy) jammy; urgency=high

  * Support setting arbitrary Locator config entries
  * Update module versions in server node
  * Use mutex to just make one json_rpc_call at a time
  * Contributors: Fabian König, Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Mon, 13 Feb 2023 23:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.7-2jammy) jammy; urgency=high

  * Fixed a bug that could cause latency in localization poses
  * Remove tf broadcaster
  * Check if laser scan message is valid
  * Add refresh timer to service callback group to avoid overlapping json rpc calls
  * Update to ROKIT Locator version 1.5
  * Contributors: Fabian König, Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 07 Sep 2022 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.6-2jammy) jammy; urgency=high

  * fix module version check for compatibility with v1.4.0
  * add parameter to enable intensities
  * Contributors: Fabian König, Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Sun, 12 Jun 2022 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.5-2jammy) jammy; urgency=high

  * update to ROKIT Locator version 1.4
  * add interface for second laser
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Tue, 15 Feb 2022 23:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.4-2jammy) jammy; urgency=high

  * handle NaNs in range values
  * add service for getting config entries
  * add server interface
  * Contributors: Stefan Laible, robertwil

 -- Stefan Laible <stefan.laible@de.bosch.com>  Sun, 23 Jan 2022 23:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.3-2jammy) jammy; urgency=high

  * update to ROKIT Locator version 1.3
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 01 Sep 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.2-2jammy) jammy; urgency=high

  * guarantee that duration_rotate is greater zero
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Wed, 21 Jul 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.1-2jammy) jammy; urgency=high

  * add tf2_geometry_msgs dependency
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Tue, 18 May 2021 22:00:00 -0000

ros-rolling-bosch-locator-bridge (2.1.0-2jammy) jammy; urgency=high

  * initial version
  * Contributors: Stefan Laible

 -- Stefan Laible <stefan.laible@de.bosch.com>  Sun, 16 May 2021 22:00:00 -0000

=== debian/control ===
Source: ros-rolling-bosch-locator-bridge
Section: misc
Priority: optional
Maintainer: Stefan Laible <stefan.laible@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), libpoco-dev, ros-rolling-ament-cmake, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-geometry-msgs, ros-rolling-launch-xml, ros-rolling-nav-msgs, ros-rolling-pcl-conversions, ros-rolling-rclcpp, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-srvs, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-bosch-locator-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpoco-dev, ros-rolling-geometry-msgs, ros-rolling-launch-xml, ros-rolling-nav-msgs, ros-rolling-pcl-conversions, ros-rolling-rclcpp, ros-rolling-rosidl-default-runtime, ros-rolling-sensor-msgs, ros-rolling-std-srvs, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-ros-workspace
Description: ROS interface to Rexroth ROKIT Locator

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
